package edu.swe622.fers.service;

import java.rmi.RemoteException;
import java.util.Map;

import org.apache.axis2.AxisFault;
import org.apache.axis2.context.ServiceContext;

import edu.swe622.fers.model.Location;
import edu.swe622.fers.model.Organization;
import edu.swe622.fers.util.ServiceUtil;

/**
 * @author Naeem
 */
public class AmbulanceService extends VehicleService {

	/**
	 * @see Vehicle.dispatchInitial()
	 * @param dst Where this vehicle is going for duty
	 */
	public void dispatch(Organization org, Location dst) {
		super.dispatchInitials(org);
		System.out.println(name + " is inside the dispatch");
		goToLocation(dst, IS_ON_MISSION);
		System.out.println(name + " after gotoLocation");
	}

	/**
	 * Reporting vehicle status to the organization responsible for this Vehicle.
	 * @param report what to be sent over there
	 */
	protected void reportBack(Location report, int status) {
		AmbulanceDispatchServiceStub orgstub;
		
		try {
			orgstub = new AmbulanceDispatchServiceStub(getUrlByID(supervisor.getUri()));
//			orgstub = new AmbulanceDispatchServiceStub("http://localhost:8080/AmbulanceDispatchServiceWEB/services/AmbulanceDispatchService.AmbulanceDispatchServiceHttpSoap12Endpoint/");
			
			AmbulanceDispatchServiceStub.VehicleUpdateReport myreport = new AmbulanceDispatchServiceStub.VehicleUpdateReport();
			myreport.setNewLocation(new AmbulanceDispatchServiceStub.Location());
			myreport.getNewLocation().setCordX(report.getCordX());
			myreport.getNewLocation().setCordY(report.getCordY());
			
			myreport.setNewVehicleID(name);
			myreport.setNewVehicleStatus(status);

			orgstub.vehicleUpdateReport(myreport);
		} catch (AxisFault e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		}
		
//		supervisor.getReport(report, name, status);
	}
	
	@Override
	public void doReturn() {
		if(supervisor == null) {
			System.out.println(name + " is inside the doReturn But no supervisor");
			return;
		}
		
		System.out.println(name + " is inside the doReturn");
		
		AmbulanceDispatchServiceStub orgstub;
		
		try {
			orgstub = new AmbulanceDispatchServiceStub(getUrlByID(supervisor.getUri()));
//			orgstub = new AmbulanceDispatchServiceStub("http://localhost:8080/AmbulanceDispatchServiceWEB/services/AmbulanceDispatchService.AmbulanceDispatchServiceHttpSoap12Endpoint/");
			
			AmbulanceDispatchServiceStub.VehicleAvailableForDispatch myreport = new AmbulanceDispatchServiceStub.VehicleAvailableForDispatch();
			myreport.setNewVehicleID(name);
			
			orgstub.vehicleAvailableForDispatch(myreport);
		} catch (AxisFault e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		}		
		
//		supervisor.released(name);		

		super.doReturn();
	}

	@Override
	public Location getCurrentLocation() {
		return super.getCurrentLocation();
	}

	@Override
	public String getName() {
		return super.getName();
	}

	@Override
	public void init(ServiceContext serviceContext) {
		super.init(serviceContext);
		
		System.out.println(name + " is completely initilized");
	}	
}
