package edu.swe622.fers.service;


import edu.swe622.fers.*;
import java.util.*;

import edu.swe622.fers.*;
import edu.swe622.fers.model.*;
import edu.swe622.fers.util.*;

import java.rmi.RemoteException;
import java.util.Map;
import org.apache.axis2.context.ServiceContext;

public class VehicleDispatchService 
{
    ArrayList<String>vehicleNameList;
    protected HashSet dispatchPool;
    protected HashSet incidents;
    protected String serviceType = "F";  // needs to be reset by child classes to A(mbulance) or F(ire).
    protected boolean initialized = false;
    protected ServiceContext serviceContext;

    
    // Service for FMS
    public void normalcyMessage (String newSchoolID) 
    {
        System.out.println("VehicleDispatchService.normalcyMessage: newSchoolID: " + newSchoolID); // Logging
         
        Iterator incidentsIterator = this.incidents.iterator();
        Incident nextIncedent;
        boolean foundMatchingIncident = false;
        
        while( incidentsIterator.hasNext() && !foundMatchingIncident )
        {
            nextIncedent = (Incident)incidentsIterator.next();
            if ( nextIncedent.getSchoolID().equals(newSchoolID) )
            {
                foundMatchingIncident = true;   
                nextIncedent.incidentRecall();
                this.incidents.remove(nextIncedent);
            }
        }
    }
    
    // Services for Vehicles

    public void vehicleUpdateReport (Location newLocation, String newVehicleID, int newVehicleStatus) 
    {
    	System.out.println("$$$$$$$$$$$$$$$$$$$$$$UPDATING -------&&&&&&&&&&&&&&&&&"+newVehicleID);
        System.out.println("VehicleDispatchService.vehicleUpdateReport: newLocation: " +  newLocation.toString() + ", newVehicleID: " + newVehicleID + ", newVehicleStatus: " + newVehicleStatus );

        Iterator dispatchPoolIterator = this.dispatchPool.iterator();
        VehicleItem nextVehicle;
        boolean foundMatchingVehicle = false;
        
        while( dispatchPoolIterator.hasNext() && !foundMatchingVehicle )
        {
            nextVehicle = (VehicleItem)dispatchPoolIterator.next();
            if ( nextVehicle.getVehicleID().equals(newVehicleID) )
            {
                foundMatchingVehicle = true;   
                nextVehicle.setStatus(newVehicleStatus);
                nextVehicle.setCurrentLocation(newLocation);
                
                this.updateGUI(nextVehicle);
            }
        }
    }
    
    
    public void vehicleAvailableForDispatch(String newVehicleID)
    {
        System.out.println( "VehicleDispatchService.vehicleAvailableForDispatch: newVehicleID: " + newVehicleID );

        Iterator dispatchPoolIterator = this.dispatchPool.iterator();
        VehicleItem nextVehicle;
        boolean foundMatchingVehicle = false;
        
        while( dispatchPoolIterator.hasNext() && !foundMatchingVehicle )
        {
            nextVehicle = (VehicleItem)dispatchPoolIterator.next();
            if ( nextVehicle.getVehicleHandle().equals(newVehicleID) )
            {
                foundMatchingVehicle = true;   
                nextVehicle.setStatus(VehicleItem.RETURNING_TO_BASE);
                this.updateGUI(nextVehicle);
            }
        }
    }
    
    protected void updateGUI(VehicleItem updatedVehicle)
    {
        String guiString = ( updatedVehicle.getVehicleID() + "|" +
                (updatedVehicle.getPreviousLocation()!= null?(int)updatedVehicle.getPreviousLocation().getCordX():-1) + "|" +
                (updatedVehicle.getPreviousLocation()!=null?(int)updatedVehicle.getPreviousLocation().getCordY():-1) + "|" +
                (int)updatedVehicle.getCurrentLocation().getCordX() + "|" +
                (int)updatedVehicle.getCurrentLocation().getCordY() + "|" +
                this.serviceType); // A or F
       System.out.println("message: in updateGUI "+guiString);
        new MQSender().send(guiString);
         //TBD Code to send String.
    }
    
    public boolean repOK()
    {
        if (this.dispatchPool == null) return false;
        if (this.incidents == null) return false;
        
        return true;
    }

    
    // Service Lifecycle Initialization
    public void init(ServiceContext newServiceContext)
    {
        this.incidents = new HashSet();
        this.dispatchPool = new HashSet();
        
        this.serviceContext = newServiceContext;
        
        vehicleNameList = (ArrayList<String>)serviceContext.getAxisService().getParameterValue("vehiclesList");
        
        System.out.println("############### Init " + serviceContext.getAxisService().toString() + "###############" );
        System.out.println("VehicleDispatchService.init: : vehicleNameList: " + vehicleNameList ); 
        
    	// Iterate through vehicleNameList and create VehicleItem objects, and add them to dispatchPool.
        Location defaultLocation = new Location(0,0);
    	for (String vehicleName : vehicleNameList) 
        {
            VehicleItem newVehicleItem = new VehicleItem( vehicleName, "http://localhost:8080/AmbulanceServiceWEB/services/AmbulanceService.AmbulanceServiceHttpSoap12Endpoint/", defaultLocation);
            this.dispatchPool.add(newVehicleItem);
        } 
    }
}

