/**
 * 
 */
package edu.swe622.fers.service;

import java.util.ArrayList;
import java.util.HashMap;

import edu.swe622.fers.model.*;
import edu.swe622.fers.util.ServiceUtil;

import junit.framework.TestCase;
import junitx.util.PrivateAccessor;

/**
 * @author kris
 *
 */
public class FireMonitoringServiceTest extends TestCase { 

	FireMonitoringService fms = new FireMonitoringService();
	/* (non-Javadoc)
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		ServiceUtil.setupProxy("juddi", "juddi");
		fms.schools = new ArrayList<String>();
		fms.schools.add("School0");
		fms.schools.add("School1");
	}
	
	public void setupFMSforTurnOffSpinklers(){
		fms.schoolSensorMap = new HashMap<String, HashMap<String,Sensor>>();
		Sensor sensor0 = new Sensor();
		sensor0.setSensorId("SensorService0");
		sensor0.setSchoolId("SchoolService0");
		sensor0.setNearestFireStation("FireMonitoringService0");
		sensor0.setStatus(1);
		sensor0.setType(FireMonitoringService.SMOKE_DETECTOR);
		
		Sensor sensor1 = new Sensor();
		sensor1.setSensorId("SensorService1");
		sensor1.setSchoolId("SchoolService0");
		sensor1.setNearestFireStation("FireMonitoringService0");
		sensor1.setStatus(1);
		sensor1.setType(FireMonitoringService.SMOKE_DETECTOR);
		
		HashMap tempMap = new HashMap<String,Sensor>();
		tempMap.put(sensor0.getSensorId(),sensor0);
		tempMap.put(sensor1.getSensorId(),sensor1);
		
		fms.schoolSensorMap.put("SchoolService0",tempMap);
		try {
			PrivateAccessor.setField(fms,"alramTriggered",new Boolean(true));
		} catch (NoSuchFieldException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	private Sensor setupSensor(int serviceno){
		Sensor sensor = new Sensor();
		sensor.setSensorId("SensorService"+serviceno);
		sensor.setSchoolId("SchoolService0");
		sensor.setNearestFireStation("FireMonitoringService0");
		sensor.setStatus(1);
		sensor.setType(FireMonitoringService.SMOKE_DETECTOR);
		return sensor;
	}
	
	
	private Sensor setupSprinkler(int serviceno){
		Sensor sensor = new Sensor();
		sensor.setSensorId("SensorService"+serviceno);
		sensor.setSchoolId("SchoolService0");
		sensor.setNearestFireStation("FireMonitoringService0");
		sensor.setStatus(1);
		sensor.setType(FireMonitoringService.FIRE_SPRINKLER);
		return sensor;
	}
	
	
	
	/* (non-Javadoc)
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	/**
	 * Test method for {@link edu.swe622.fers.service.FireMonitoringService#monitorSensors()}.
	 */
	public void testMonitorSensors() {
		
	}

	/**
	 * Test method for {@link edu.swe622.fers.service.FireMonitoringService#updateStatus(edu.swe622.fers.model.Sensor)}.
	 */
	public void testUpdateStatus() {
		Sensor sensor = setupSensor(0);
		fms.updateStatus(sensor);
		Sensor sensor1 = setupSensor(1);
		fms.updateStatus(sensor1);
	}
	
	public void testUpdateStatusSprinkler() {
		Sensor sensor = setupSprinkler(4);
		fms.updateStatus(sensor);
	}
	
	public void testTurnOffAllSpinklers(){
		
		setupFMSforTurnOffSpinklers();
		
		Sensor sensor = setupSensor(0);
		sensor.setStatus(0);
		fms.updateStatus(sensor);
		
		Sensor sensor1 = setupSensor(1);
		sensor1.setStatus(0);
		fms.updateStatus(sensor1);
		
		
	}

}
